#pragma once

#include <string>
#include <map>
#include <vector>

#include "BeckyApi.h"

////////////////////////////////////////////////////////////////////////
// tH_IEBhE
////////////////////////////////////////////////////////////////////////

class CBrowseBeckyFolderDlg2
{
public:
	// RXgN^
	CBrowseBeckyFolderDlg2(CBeckyAPI* pbka);
	// fXgN^
	virtual ~CBrowseBeckyFolderDlg2();

public:
	// \
	int DoModal(HWND hWndParent, const char* bkaDataFolder, const char* selFolder, const char* pTitle);
	// IꂽpX擾
	std::string GetFolderPath();

private:
	// _CAOvV[W(]p)
	static BOOL CALLBACK DialogProcStatic(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	// _CAOvV[W
	BOOL DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	// WM_INITDIALOG nh
	BOOL OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam);
	// WM_COMMAND nh
	void OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify);
	// WM_NOTIFY nh
	BOOL OnNotify(HWND hWnd, int idCtrl, NMHDR* pnmhdr);

private:
	// c[r[ɃGNXv[[X^CKp
	void ApplyTreeViewExplorerStyle(HWND hWnd);
	// c[r[ɃtH_ǉ
	void AddTreeViewBeckyFoler(const char* parentFolder, HWND hTreeView, HTREEITEM hParent, int findLevel);
	// w̃tH_z̃tH_ꗗ𓾂
	void GetFolderList(const char* parentFolder, std::vector<std::string>* pFolderNameList);

private:
	// Becky! ̃f[^tH_
	std::string m_bkaDataFolder;
	// IĂtH_
	std::string m_selFolder;
	// ^Cg
	const char* m_pTitle;
	// tH_pC[WXg
	HIMAGELIST m_hImgList;
	// tH_ꗗ
	std::map<std::string, HTREEITEM> m_folderList;
	// IꂽpXێ
	std::string m_folderPath;
	// Becky! API ւ̎Q
	CBeckyAPI* m_pbka;

private:
	// g̃CX^X
	static CBrowseBeckyFolderDlg2* s_pThis;
};

